<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Three Operand Instructions</TITLE>
<link href="suif1_33.html" rel=Next>
<link href="suif1_31.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_31.html">previous</A>, <A HREF="suif1_33.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC32" HREF="suif1_toc.html#TOC32">Three Operand Instructions</A></H2>
<P>
<A NAME="IDX180"></A>
<A NAME="IDX181"></A>

</P>
<P>
<A NAME="IDX182"></A>
The vast majority of SUIF instructions are represented by the
<CODE>in_rrr</CODE> class which includes fields for two source operands.  Not
all of the operands have to be used.  For example, <CODE>nop</CODE>
instructions don't use any operands at all.

</P>
<P>
<A NAME="IDX183"></A>
<A NAME="IDX184"></A>
<A NAME="IDX185"></A>
<A NAME="IDX186"></A>
The <CODE>src1_op</CODE> and <CODE>src2_op</CODE> methods retrieve the source
operands, and the <CODE>set_src1</CODE> and <CODE>set_src2</CODE> methods assign new
operands.  Besides the methods to directly access the two source
operands, other methods are provided to refer to these sources according
to their uses with specific opcodes:

</P>

<UL>
<LI>

<A NAME="IDX187"></A>
<A NAME="IDX188"></A>
Shift and rotate instructions (<CODE>asr</CODE>, <CODE>lsl</CODE>, <CODE>lsr</CODE>, and
<CODE>rot</CODE>) may use the <CODE>shift_cnt_op</CODE> and <CODE>set_shift_cnt_op</CODE>
methods to access the operand that specifies the numbers of bits to
shift or rotate.  The other source operand may be accessed with the
<CODE>src_op</CODE> and <CODE>set_src</CODE> methods.

<LI>

<A NAME="IDX189"></A>
<A NAME="IDX190"></A>
Store (<CODE>str</CODE>) and memory copy (<CODE>memcpy</CODE>) instructions may use
the <CODE>dst_addr_op</CODE> and <CODE>set_dst_addr_op</CODE> methods to access the
source operand that holds the destination address for the memory
reference.

<LI>

<A NAME="IDX191"></A>
<A NAME="IDX192"></A>
Load (<CODE>lod</CODE>) and memory copy (<CODE>memcpy</CODE>) instructions may use
the <CODE>src_addr_op</CODE> and <CODE>set_src_addr_op</CODE> methods to access the
operand that specifies the source address for the memory reference.
Note that the actual operand field that is used is different for these
two opcodes.

<LI>

<A NAME="IDX193"></A>
<A NAME="IDX194"></A>
Instructions that only use one of the source operands may use the
<CODE>src_op</CODE> and <CODE>set_src</CODE> methods without specifying whether the
first or second operand field is used.  In addition, a store
(<CODE>str</CODE>) instruction may use these methods to refer to the operand
holding the value to be stored.  They are also used by shift and rotate
instructions as described above.
</UL>

<P>
Using these opcode-specific methods with the wrong opcodes will cause
errors.

</P>
<P>
<A NAME="IDX195"></A>
For your convenience, the <CODE>in_rrr</CODE> class provides a method,
<CODE>is_unary</CODE>, to determine if an instruction produces a result value
using only one of the source operands.  It does not consider return
(<CODE>ret</CODE>) instructions to be unary because they do not produce result
values.  Although load (<CODE>lod</CODE>) instructions fit the pattern, they
are a special case and are not considered to be unary.

</P>
<P>
<A NAME="IDX196"></A>
The <CODE>is_commutative</CODE> method checks the opcode of an instruction to
determine if it is a commutative operation.  If so, the two source
operands should be interchangeable.

</P>
<P>
Some of the arithmetic instructions may generate run-time exceptions if
the appropriate class of exceptions is enabled (see section <A HREF="suif1_78.html#SEC78">Miscellaneous Annotations</A>).  If the exceptions are not enabled, the rules for ANSI C
are used to determine the result.

</P>
<P>
The following table lists all of the three operand SUIF instructions.
Each entry describes the operands used with that opcode and includes any
restrictions on the operand and result types.

</P>
<DL COMPACT>

<DT><CODE>nop</CODE>
<DD>
Do nothing at all.  All of the operands for these instructions
should be null, and the result type should be the SUIF <CODE>void</CODE> type.

<DT><CODE>lod</CODE>
<DD>
Load the value at the address contained in the <CODE>src1</CODE> operand and
put it in the <CODE>dst</CODE> operand.  The result type indicates the type
of the value being loaded and may be any type, subject to the usual
restrictions on a result type (see section <A HREF="suif1_26.html#SEC26">Result Types</A>).  The type of the
expression in <CODE>src1</CODE> must be a pointer to the result type.  The
<CODE>src2</CODE> operand is not used.

<DT><CODE>str</CODE>
<DD>
Store the value in the <CODE>src2</CODE> operand at the address contained in
the <CODE>src1</CODE> operand.  Both operands must be specified.  There is
no special restriction on the type of the <CODE>src2</CODE> operand, though
the restrictions on instruction result types (see section <A HREF="suif1_26.html#SEC26">Result Types</A>)
and variables (see section <A HREF="suif1_55.html#SEC55">Variable Symbols</A>) guarantee it will have a
known, non-zero size.  The <CODE>src1</CODE> operand should contain an
expression that is a pointer to the type of the operand being stored.
The <CODE>dst</CODE> operand is not used.

<DT><CODE>memcpy</CODE>
<DD>
Memory to memory copy.  Load the value from the address in the
<CODE>src2</CODE> operand and store it at the address in the <CODE>src1</CODE>
operand.  The type of the object to be copied is subject to the same
conditions as the result type of an instruction (see section <A HREF="suif1_26.html#SEC26">Result Types</A>), so it must have known, non-zero size.  Both of the source
operands must be pointers to this object type.  The <CODE>dst</CODE> operand
is not used.

<DT><CODE>cpy</CODE>
<DD>
Copy the <CODE>src1</CODE> operand to the <CODE>dst</CODE> operand.  The
<CODE>src2</CODE> operand is not used.  The result type must be the same as
the type of the source operand.  The restrictions on instruction
result types (see section <A HREF="suif1_26.html#SEC26">Result Types</A>) guarantee that the object being
copied has known, non-zero size.

<DT><CODE>cvt</CODE>
<DD>
Convert the <CODE>src1</CODE> operand to the result type and put it in the
<CODE>dst</CODE> operand.  The <CODE>src2</CODE> operand is not used.  Nothing can
can be converted to or from a <CODE>struct</CODE>, <CODE>union</CODE>,
<CODE>array</CODE>, or <CODE>void</CODE> type.  Pointer types can only be
converted to and from integer types and other pointer types.

<DT><CODE>neg</CODE>
<DD>
Negation.  Change the sign of the value in the <CODE>src1</CODE> operand and
put the result in the <CODE>dst</CODE> operand.  The <CODE>src2</CODE> operand is
unused.  The result type and the type of the operand must be the same
signed integer or floating-point type.

<DT><CODE>add</CODE>
<DD>
Add the values in the <CODE>src1</CODE> and <CODE>src2</CODE> operands and put the
result in the <CODE>dst</CODE> operand.  Except for pointer additions, the
result type and the types of the operands must be the same integer or
floating-point types.  Pointer addition is a special case.  One of the
source operands may have a pointer type, as long as the other source
operand has signed or unsigned integer type of any size; the result
type must also be a pointer type, but need not be the same as the
source pointer type.

<DT><CODE>sub</CODE>
<DD>
Subtract the value in the <CODE>src2</CODE> operand from the value in the
<CODE>src1</CODE> operand and put the result in the <CODE>dst</CODE> operand.
Except for pointer subtractions, the result type and the types of the
operands must be the same integer or floating-point types.  There are
two special cases for pointer subtractions.  In either case, the
<CODE>src1</CODE> operand must have a pointer type.  First, the <CODE>src2</CODE>
operand may have any integer type, in which case the result type may
be any pointer type, not necessarily the same as the source pointer
type.  Second, the <CODE>src2</CODE> operand's type may be another pointer,
in which case the result type must be type_ptr_diff.

<DT><CODE>mul</CODE>
<DD>
<DT><CODE>div</CODE>
<DD>
Multiply or divide the value in the <CODE>src1</CODE> operand by the value in
the <CODE>src2</CODE> operand and put the result in the <CODE>dst</CODE> operand.
The result type and the types of the operands must be the same integer
or floating-point type.  Integer multiplication and division are
defined according to the rules for ANSI C.

<DT><CODE>rem</CODE>
<DD>
<DT><CODE>mod</CODE>
<DD>
Remainder and modulus.  These two instructions are very similar.  Both
divide the value in the <CODE>src1</CODE> operand by the value in the
<CODE>src2</CODE> operand to find the remainder or modulus.  The <CODE>rem</CODE>
instruction is identical to the modulus operator in ANSI C.  That
is, if either source operand is negative, the sign of the result is
undefined and depends on the semantics of integer division.  The
<CODE>mod</CODE> instruction is the same except that its result is always
guaranteed to be positive.  The result type and the types of the
destination and source operands must be the same integer type.

<DT><CODE>not</CODE>
<DD>
Bit-wise inversion.  Compute the one's complement negation of the value
in the <CODE>src1</CODE> operand and put the result in the <CODE>dst</CODE> operand.
The <CODE>src2</CODE> operand is not used.  The result type and the types of
the operand must be the same unsigned integer type.

<DT><CODE>and</CODE>
<DD>
<DT><CODE>ior</CODE>
<DD>
<DT><CODE>xor</CODE>
<DD>
Compute the bit-wise AND, inclusive OR, or exclusive OR of the values in
the <CODE>src1</CODE> and <CODE>src2</CODE> operands and put the result in the
<CODE>dst</CODE> operand.  The result type and the type of the operands must
be the same unsigned integer type.

<DT><CODE>asr</CODE>
<DD>
<DT><CODE>lsr</CODE>
<DD>
<DT><CODE>lsl</CODE>
<DD>
Shift the value in the <CODE>src1</CODE> operand right or left by the amount
specified in the <CODE>src2</CODE> operand.  The variable in the <CODE>src2</CODE>
operand must always have an unsigned integer type.  The <CODE>asr</CODE>
instruction performs sign extension and requires that the result type
and the type <CODE>src1</CODE> operand be the same signed integer type.  The
<CODE>lsr</CODE> instructions does not perform sign extension and requires
that the result type and type of the <CODE>src1</CODE> operand be the same
unsigned integer type.  Sign extension is not an issue for left
shifts, so the <CODE>lsl</CODE> instruction only requires that the result
type and the type of the <CODE>src1</CODE> operand be the same integer type.

<DT><CODE>divfloor</CODE>
<DD>
<DT><CODE>divceil</CODE>
<DD>
Division combined with floor and ceiling operations.  The
<CODE>divfloor</CODE> opcode means take the rational quotient of the
<CODE>src1</CODE> operand by the <CODE>src2</CODE> operand and apply the floor
operation (i.e. round to the nearest integer less than or equal to the
quotient).  The <CODE>divceil</CODE> opcode means take the rational quotient
of the <CODE>src1</CODE> operand by the <CODE>src2</CODE> operand and apply the
ceiling operation (i.e. round to the nearest integer greater than or
equal to the quotient).  The result type and the operand types must be
the same integer type.

<DT><CODE>min</CODE>
<DD>
<DT><CODE>max</CODE>
<DD>
Minimum and maximum.  The result value is the minimum or maximum,
respectively, of the two source operands.  The result type and the
operand types must be the same integer or floating-point types.

<DT><CODE>abs</CODE>
<DD>
Absolute value.  Compute the absolute value of the <CODE>src1</CODE> operand.
The <CODE>src2</CODE> operand is unused.  The result type and the source
operand type must be the same integer or floating-point type.

<DT><CODE>rot</CODE>
<DD>
Rotate the value in the <CODE>src1</CODE> operand left or right by the amount
specified in the <CODE>src2</CODE> operand.  The variable in the <CODE>src2</CODE>
operand must always have a signed integer type.  If the shift
amount is positive, the value is rotated to the left (toward the
most-significant bit); if it is negative, the value is rotated to the
right.  The result type and the type of the <CODE>src1</CODE> operand must
be the same integer type.

<DT><CODE>seq</CODE>
<DD>
<DT><CODE>sne</CODE>
<DD>
<DT><CODE>sl</CODE>
<DD>
<DT><CODE>sle</CODE>
<DD>
Comparison instructions.  If the <CODE>src1</CODE> operand is equal, not
equal, less than, or less than or equal, respectively, to the
<CODE>src2</CODE> operand, assign the integer value one to the <CODE>dst</CODE>
operand.  Otherwise, set the <CODE>dst</CODE> operand to zero.  The result
type must always be a signed integer type.  The source operands must
have integer, enumerated, floating point, or pointer type.

<DT><CODE>ret</CODE>
<DD>
Return from a procedure.  Only the <CODE>src1</CODE> operand is used and it
is optional.  If specified, it is the return value and may contain an
operand of any type except array or function types.  If the
procedure's function type has void return type, the operand must be
null; otherwise the operand must not be null and must have the same
type as the return type of the procedure.

<DT><CODE>mrk</CODE>
<DD>
This pseudo-instruction only marks a position in the program and is used
to hold miscellaneous annotations such as line numbers.  It is
functionally equivalent to a <CODE>nop</CODE> instruction.  All of the
operands for these instructions should be null, and the result type
should be the SUIF <CODE>void</CODE> type.
</DL>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_31.html">previous</A>, <A HREF="suif1_33.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
